<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
  <xsl:param name="cg_name" select="'busy_range_cg'" />
  <xsl:param name="show_weight_zero" select="'no'" />
  <xsl:param name="instance_name" select="''" />
  
  <xsl:template match="/">
    <xsl:apply-templates select="testbench"/>
  </xsl:template>
  
  <xsl:template match="testbench">
    <xsl:apply-templates select="cg[@name=$cg_name]" />
  </xsl:template>
  
  <xsl:template match="cg">
    <table summary="instance selecter" id="instmenutable">
      <tbody>
	<tr>
	  <td>
	    <xsl:choose>
	      <xsl:when test="$instance_name=''">
		<xsl:attribute name="class">selected</xsl:attribute>
	      </xsl:when>
	      <xsl:otherwise>
		<xsl:attribute name="onclick">switchmode('<xsl:value-of select="@instname"/>')</xsl:attribute>
	      </xsl:otherwise>
	    </xsl:choose>
	    cumulative
	    <br/>
	    <span>
	      <xsl:call-template name="ranking"><xsl:with-param name="score" select="cumulative/@score"/></xsl:call-template>
	      score:<xsl:value-of select="cumulative/@score" />
	    </span>
	  </td>
	</tr>
	  <xsl:for-each select="inst">
	    <xsl:if test="@weight&gt;0 or $show_weight_zero='yes'">
	      <tr>
		<td>
		  <xsl:choose>
		    <xsl:when test="$instance_name=@instname">
		      <xsl:attribute name="class">selected</xsl:attribute>
		    </xsl:when>
		    <xsl:otherwise>
		      <xsl:attribute name="onclick">switchmode('<xsl:value-of select="@instname"/>')</xsl:attribute>
		    </xsl:otherwise>
		  </xsl:choose>
		  <xsl:value-of select="@instname"/>
		  <br/>
		  <span class="scorespan">
		    <xsl:call-template name="ranking"><xsl:with-param name="score" select="@score"/></xsl:call-template>

		    score:<xsl:value-of select="@score" />
		  </span>
		</td>
	      </tr>
	    </xsl:if>
	  </xsl:for-each>
      </tbody>
    </table>
  </xsl:template>

  <xsl:template name="ranking">
    <xsl:param name="score" />
    <xsl:choose>
      <xsl:when test="$score=100"><xsl:attribute name="class">Lv5</xsl:attribute></xsl:when>
      <xsl:when test="$score&gt;=80"><xsl:attribute name="class">Lv4</xsl:attribute></xsl:when>
      <xsl:when test="$score&gt;=60"><xsl:attribute name="class">Lv3</xsl:attribute></xsl:when>
      <xsl:when test="$score&gt;=30"><xsl:attribute name="class">Lv2</xsl:attribute></xsl:when>
      <xsl:when test="$score&gt; 0"><xsl:attribute name="class">Lv1</xsl:attribute></xsl:when>
      <xsl:when test="$score=0"><xsl:attribute name="class">Lv0</xsl:attribute></xsl:when>
      <xsl:otherwise></xsl:otherwise>
    </xsl:choose>    
  </xsl:template>
</xsl:stylesheet>