/*
* Copyright (C) 2007-2012 Verifore, Inc.
* All rights reserved. Property of Verifore, Inc.
* Restricted rights to use, duplicate or disclose
* this code are granted through contract.
*/

var aryQuery = new Object;
var xml, xslt2;
var ccdat;
var aryAxisNames, aryBinNames;
var aryDimension, aryCond;
var at_least;
var maxRows=100;
var strTableHeadForIE;
var statView;

function assert(arg)
{
    if(!arg) {
	eval(assertfails);
    }
}

function initialize()
{
    var drawMode = 'normal';
    var filename="result.xml";
    var instanceName = "";
    
    // get file name from Query
    if(location.search.length==0){
	$('menulist').innerHTML = "";
	$('additional').innerHTML = "<h3>paramete error...(no cg & cp is defined.)</h3>";
	return;
    }
    if(location.search.length > 1){
	var ary = location.search.substr(1).split("&");
	ary.each(
	    function(str){
		var key_val = str.split("=");
		aryQuery[key_val[0]] = decodeURI(key_val[1]);
	    });
    }
    if(aryQuery['drawMode']) drawMode = aryQuery['drawMode'];
    if(aryQuery['target']) filename = aryQuery['target'];
    if(aryQuery['instance']) instanceName = aryQuery['instance'];

    var xslt3,xslt4;
    if(!document.all){ //Mozilla
	xml = document.implementation.createDocument("", "", null);
	xslt2 = document.implementation.createDocument("", "", null);
        xslt3 = document.implementation.createDocument("", "", null);
        xslt4 = document.implementation.createDocument("", "", null);
    }
    else {
	xml = new ActiveXObject("Msxml2.DOMDocument");
	xslt2 = new ActiveXObject("Msxml2.FreeThreadedDOMDocument");
	xslt3 = new ActiveXObject("Msxml2.FreeThreadedDOMDocument");
	xslt4 = new ActiveXObject("Msxml2.FreeThreadedDOMDocument");
    }
    xml.async = false;
    xslt2.async = false;
    xslt3.async = false;
    xslt4.async = false;

    xml.load(filename);
    xslt2.load('toolbox/ViewCCHeader.xsl');
    xslt3.load('toolbox/ViewCCFirst.xsl');
    xslt4.load('toolbox/InstanceSelector.xsl');

    //create selecter menu
    createXsltProc(xslt4);
    setXsltProcParameter('cg_name', aryQuery['cg']);
    setXsltProcParameter('instance_name', instanceName);
    transformXmlAndWriteToDiv(xml, 'instselector');    

    //
    createXsltProc(xslt3);
    setXsltProcParameter('cg_name', aryQuery['cg']);
    setXsltProcParameter('cc_name', aryQuery['cp']);
    setXsltProcParameter('instance_name', instanceName);
    xml = transform(xml);
    xslt3 = null;
    
    // analyze datas
    var strdat;
    var node = xml.documentElement.getElementsByTagName("data")[0];
    if(!document.all){ //Mozilla
	strdat = trim(node.textContent).split(' ');
    } else {
	strdat = trim(node.text).split(' ');
    }
    node.removeChild(node.firstChild);
    node=null;

    ccdat = new Array(strdat.length);
    for(var i=0; i<strdat.length; i++){ ccdat[i]=eval(strdat[i]); }

    // get names of axis & bins
    nodes = xml.documentElement.getElementsByTagName("crosspoints");
    nodes = nodes[0].getElementsByTagName("axis");

    aryAxisNames = new Array;
    aryBinNames = new Array;
    aryDimension = new Array;

    for(var i=0; i<nodes.length; i++){
	aryAxisNames.push(nodes[i].getAttributeNode("name").value);
	aryDimension.push(nodes[i].getAttributeNode("n_bins").value);
	var ary = new Array;
	var bn_nodes = nodes[i].getElementsByTagName("bn");

	for(j=0; j<bn_nodes.length; j++)
	  ary.push(bn_nodes[j].getAttributeNode("name").value);
	aryBinNames.push(ary);

    }
    aryCond = new Array(aryAxisNames.length);
    for(var i=0; i<aryCond.length; i++) aryCond[i] = null;

    // get at least
    var propNode = xml.documentElement.getElementsByTagName("property")[0];
    //  at_least = eval(propNode.getAttributeNode("at_least").value);
    at_least = 1;

    statView = new StatisticView();

    if(drawMode == 'normal') {
	//show base statistics
	showHeaderInfo();
	showStatView();
    } else {
	var cond = new Array(aryAxisNames.length);
	for(var i=0; i<cond.length; i++) cond[i]=null;
	//scan constraint
	for(var key in aryQuery){
	    var aryKey = key.split(':');
	    if(aryKey.length>1 && aryKey[0]=='cons'){
		var ax = scanStrArray(aryAxisNames, aryKey[1]);
		var bn = scanStrArray(aryBinNames[ax], aryQuery[key]);
		cond[ax]=bn;
	    }
	}
	var tablesrc = "";
	if(drawMode=='1D')
	  tablesrc=statView.createTable(cond, scanStrArray(aryAxisNames,aryQuery['axis']), null);
	else {
	    var axh = scanStrArray(aryAxisNames, aryQuery['axis']);
	    var axv = scanStrArray(aryAxisNames, aryQuery['axisV']);
	    if(drawMode=='2D') tablesrc=statView.draw2dChart(cond, axh, axv, false);
	    else if(drawMode=='bn')
	      tablesrc=statView.draw2dBinChart(cond, axh, axv, false);
	}
	var dombody = document.getElementsByTagName('body')[0];
	dombody.innerHTML = tablesrc;
    }
}

function scanStrArray(ary,target)
{
    for(var i =0; i<ary.length; i++){
	if(ary[i]==target) return i;
    }
    return -1;
}


function coordToIndex(ary)
{
    assert(ary.length == aryDimension.length);
    retval = ary[0];
    for(var i=1; i<ary.length; i++){
	retval = retval*aryDimension[i] + ary[i];
    }
    return retval;
}

function trim(string)
{
    return string.replace(/^\s+|\s+$/g, "");
}
function showHeaderInfo(rootnode)
{
    createXsltProc(xslt2);
    transformXmlAndWriteToDiv(xml, 'infoHeader');
}

function showListView(aryConstraints, minCount)
{
    $('openwindow').style.visibility = 'hidden';
    // create list table header
    if(aryConstraints == null){
	aryConstraints = new Array(aryAxisNames.length);
	for(var i=0; i<aryConstraints.length; i++) aryConstraints[i] = null;
    }

    // aryConstraints must be [null,0,1,null,null...] form. Null is wild-card.
    assert(aryConstraints.length == aryAxisNames.length);

    var strTable = new Array;

    // table frame
    strTable.push("<table summary='cc_list_view' class='maintable'>");
    strTable.push("<caption>Auto Cross Coverage List View</caption>");
    strTable.push("<thead><tr id='tablehead'>");

    for(var i=0; i<aryAxisNames.length; i++){
	strTable.push("<th scope='col'>" + aryAxisNames[i]+"<br/>");
	strTable.push("<select onchange=rescanList() id='" + i + "'>");
	strTable.push("<option>all</option>");
	for(j=0; j<aryBinNames[i].length; j++){
	    strTable.push("<option>"+aryBinNames[i][j]+"</option>");
	}
	strTable.push("</select></th>");
    }
    strTable.push("<th scope=col class='countcol'>count</th>");

    strTable.push("<th scope=col class='scorecol'>state<br/>");
    strTable.push("<select onchange=rescanList() id='state_cond'>");
    strTable.push("<option>all</option><option>ok</option><option>ng</option><option>excluded</option>");
    strTable.push("</select></th>");

    strTable.push("</tr></thead>");
    strTable.push("<tbody id='listbody'>");
    strTable.push("</tbody>");
    strTable.push("</table>");
    $('main').innerHTML=strTable.join("");

    if(document.all){//IE
	strTableHeadForIE = strTable.join("").replace("</tbody></table>","");
    }
    rescanList();
    strTable = null;
}

function binScanner(in_cond)
{
    this.coord = new Array(in_cond.length);
    this.constraint = new Array(in_cond.length);
    this.setCondition(in_cond);
}

binScanner.prototype.setCondition = function(in_cond)
{
    assert(in_cond.length==aryDimension.length);
    assert(in_cond.length==aryBinNames.length);
    for(var i=0; i<in_cond.length; i++){
	if(in_cond[i]==null) this.coord[i]=0;
	else this.coord[i]=in_cond[i];
	this.constraint[i]=in_cond[i];
    }

    // search least count up axis
    for(var i=in_cond.length-1; i>=0 && in_cond[i]!=null; i--);
    this.addpoint = i;
}

binScanner.prototype.resetCondition = function(idx, val)
{
    this.constraint[idx] = val;
    this.setCondition(this.constraint);
}	 

binScanner.prototype.inc = function()
{
    // return true if increment success
    // if end, return false
    for(current=this.addpoint; current>=0 && this.coord[current]==aryDimension[current]-1;){
	this.coord[current] = 0;
	for(current--; current>=0 && this.constraint[current]!=null; current--);
    }
    if(current<0) return false;
    this.coord[current]++;
    return true;
}

function rescanList()
{
    $('additional').innerHTML = "";
    var strTable = new Array;

    // scan pulldown boxes
    for(var i=0; i<aryCond.length; i++){
	selected = $(""+i).selectedIndex;
	if(selected==0) aryCond[i]=null;
	else aryCond[i]=selected-1;
    }

    var stateCond = $('state_cond').selectedIndex;
    var scanner = new binScanner(aryCond);
    
    // start scan
    var counter;
    for(counter=0; counter<maxRows; ){
	var bShow =false;
	var d = ccdat[coordToIndex(scanner.coord)];
	if(d>=0){
	    if(stateCond==0) bShow = true;
	    if(stateCond==1 && d>=at_least) bShow = true;
	    if(stateCond==2 && d<at_least) bShow = true;
	}
	else {
	    if(stateCond==3) bShow=true;
	}
	if(bShow) {
	    counter++;
	    strTable.push("<tr>");
	    for(var i=0; i<aryCond.length; i++){
		strTable.push("<td>" + aryBinNames[i][scanner.coord[i]] + "</td>");
	    }
	    if(d>=0)strTable.push("<td>"+d+"</td>");
	    else strTable.push("<td/>");

	    if(d>=at_least) strTable.push("<td class=ok>ok</td>");
	    else if(d==-3) strTable.push("<td>illegal</td>");
	    else if(d==-2) strTable.push("<td>excluded</td>");
	    else if(d==-1) strTable.push("<td>named</td>");
	    else strTable.push("<td class=ng>ng</td>");
	    strTable.push("</tr>");
	}

	if(!scanner.inc()) break;
    }
    if(!document.all){ //Mozilla
	$('listbody').innerHTML = strTable.join("");
    } else {
	stri =  strTableHeadForIE + "<tbody>" + strTable.join('\n')+"</tbody></table>";
	$('main').innerHTML = strTableHeadForIE + "<tbody>" + strTable.join('')+"</tbody></table>";
	setPulldownBoxes(aryCond, stateCond);
    }
    if(counter==maxRows)
      $('additional').innerHTML = "more than "+ maxRows + "  items hit...";
}

function setPulldownBoxes(coord, state_cond)
{
    assert(coord.length == aryAxisNames.length);
    for(var i=0; i<coord.length; i++){
	if(coord[i]==null) $(""+i).selectedIndex=0;
	else $(""+i).selectedIndex =  coord[i]+1;
    }
    $('state_cond').selectedIndex = state_cond;
}

function StatisticView()
{
    this.aryCurrentShown = new Array;
    this.HorizontalAxis = null;
    this.VerticalAxis = null;
}

StatisticView.prototype.initialize = function()
{
    for(var i=0; i<aryDimension.length; i++){
	elem = document.createElement('div');
	elem.setAttribute('id', 'block'+i);
	$('main').appendChild(elem);
    }
    this.aryCurrentShown = new Array;
}

StatisticView.prototype.createConditionArray = function(condarray)
{
    assert(condarray.length == aryDimension.length);
    var current;
    for(var i=0; i<condarray.length; i++) condarray[i]=null;
    for(current=0; current<this.aryCurrentShown.length; current++){
	condarray[this.aryCurrentShown[current][0]] = this.aryCurrentShown[current][1];
    }
    return current;
}

StatisticView.prototype.createConstraintString = function()
{
    var strAry = new Array;
    strAry.push("Constraint:<br/>");
    this.aryCurrentShown.each(
	function(cond){
	    strAry.push(aryAxisNames[cond[0]]);
	    strAry.push(" = ");
	    strAry.push(aryBinNames[cond[0]][cond[1]]);
	    strAry.push("<br/>");
	});
    return strAry.join('');
}
StatisticView.prototype.createURL = function(drawMode, axisH, axisV)
{
    var strAry = new Array;
    strAry.push(location.href);
    strAry.push('&drawMode='+drawMode);
    strAry.push('&axis='+aryAxisNames[axisH]);
    if(axisV!=null) strAry.push('&axisV='+aryAxisNames[axisV]);
    this.aryCurrentShown.each(
	function(cond){
	    strAry.push('&cons:');
	    strAry.push(aryAxisNames[cond[0]]);
	    strAry.push("=");
	    strAry.push(aryBinNames[cond[0]][cond[1]]);
	});
    return strAry.join('');
}
StatisticView.prototype.rewind = function(pos)
{
    while(this.aryCurrentShown.length>pos){
	$('block'+this.aryCurrentShown.length).innerHTML = "";
	this.aryCurrentShown.pop();
    }
}
StatisticView.prototype.add = function(axisId, binId)
{
    this.aryCurrentShown.push([axisId, binId]);
}

function showStatView() //call back function
{
    $('openwindow').style.visibility = 'visible';

    $('main').innerHTML = "";
    $('additional').innerHTML = "";
    statView.initialize();
    statView.drawStatisticView(null);
}	 

function changeAxis(axisId, pos) //call back function
{
    if(pos!=null) statView.rewind(pos);
    statView.drawStatisticView(axisId);
}

function chartExpand(axisHor, axisVer, pos) // call back function
{
    if(pos==null) pos = statView.aryCurrentShown.length;
    statView.rewind(pos);
    var condition = new Array(aryAxisNames.length);
    statView.createConditionArray(condition);
    if(axisVer==null){
        condition[axisHor]=0;
        for(var axisVer=0; axisVer<condition.length && condition[axisVer]!=null; axisVer++);
        condition[axisHor]=null;
    }
    assert(axisVer<condition.length);
    assert(condition[axisVer]==null);
    
    $('block'+pos).innerHTML = statView.draw2dChart(condition, axisHor, axisVer, true);
    $('additional').innerHTML = statView.createConstraintString();
    $('openwindow').setAttribute('onclick', "window.open('"+statView.createURL('2D', axisHor,axisVer)+"')");
}

function close2DChart(axisId) // call back function
{
    statView.drawStatisticView(axisId);
}

function dyeCharacter(tbl, n)
{
    var tds = tbl.getElementsByTagName("tbody")[0].getElementsByTagName("tr")[0].getElementsByTagName("td");
    for(var i=0; i<tds.length; i++) tds[i].style.color = '#000';
    tds[n].style.color = '#9999ff';
    
}

function listExpand(td,axisId, binId) // call back function
{
    for(var i=0; i<statView.aryCurrentShown.length; i++){
	if(statView.aryCurrentShown[i][0]==axisId){
	    statView.rewind(i); break;
	}
    }
    
    statView.add(axisId, binId);
    statView.drawStatisticView(null);
    dyeCharacter(td.parentNode.parentNode.parentNode, binId);
}

function closeAndAppendChart(row, col)// call back function
{
    var hor = statView.HorizontalAxis;
    var ver = statView.VerticalAxis;

    var tbl = statView.drawStatisticView(hor);
    dyeCharacter(tbl, col);
    statView.add(hor, col);
    
    if(statView.aryCurrentShown.length<aryDimension.length-2){
	tbl = statView.drawStatisticView(ver);
	dyeCharacter(tbl, row);
	statView.add(ver, row);
    }
    statView.drawStatisticView(null);
}

StatisticView.prototype.drawStatisticView = function(axisId)
{
    // initialize condition array
    // if axisId==0 then search next axis automatically.
    var condition = new Array(aryAxisNames.length);
    var current = this.createConditionArray(condition);
    this.HorizontalAxis = null;
    this.VerticalAxis = null;

    // search&set target axis if not defined
    if(axisId==null) for(axisId=0; condition[axisId]!=null; axisId++);
    
    $('block'+current).innerHTML = "";
    if(current==aryDimension.length-2){
        var axisIdVer;
	condition[axisId] = 0;
        for(axisIdVer=0; condition[axisIdVer]!=null; axisIdVer++);
	condition[axisId] = null;
	$('block'+current).innerHTML=this.draw2dBinChart(condition, axisId, axisIdVer, true);
	$('openwindow').setAttribute('onclick', "window.open('"+ this.createURL('bn', axisId,axisIdVer) + "')");
    } else {
	$('block'+current).innerHTML=this.createTable(condition, axisId, current);
	$('openwindow').setAttribute('onclick', "window.open('"+ this.createURL('1D', axisId, null) + "')");
    }
    $('additional').innerHTML = statView.createConstraintString();
    
    return $('block'+current).getElementsByTagName('table')[0];
}

StatisticView.prototype.axisNotShown = function()
{
    var used = new Array; 
    aryCurrentShown.each(
	function(axis) {
	    used[axis[0]] = true;
	});
    return used;
}	

StatisticView.prototype.drawBlock = function(blockid)
{
    
}

StatisticView.prototype.createTable = function(aryCondition, id_axis, pos)
{
    var strTbl = new Array;
    strTbl.push("<table class='statTable'>");
    if(pos!=null){
	strTbl.push("<caption>AXIS: ");

	for(var i=0; i<aryCondition.length; i++){
	    if(aryCondition[i]==null){
		if(i!=id_axis){
		    strTbl.push("<a onclick='changeAxis("+ i + "," + pos + ")' style='margin-right:20pt;'>");
		    strTbl.push(aryAxisNames[i]);
		    strTbl.push("</a>");
		} else {
		    strTbl.push("<span style='margin-right:20pt;'>");
		    strTbl.push(aryAxisNames[i]);
		    strTbl.push("</span>");
		}
	    }
	}
	strTbl.push("<a onclick='chartExpand("+id_axis+",null,"+pos+")'>  [open 2D &gt;&gt;]</a>");
	strTbl.push("</caption>");
    }
    strTbl.push("<thead><tr>");
    for(var i=0; i<aryBinNames[id_axis].length; i++){
        strTbl.push("<th scope='col'>");
        strTbl.push(aryBinNames[id_axis][i]);
        strTbl.push("</th>");
    }
    strTbl.push("</tr></thead>");
    strTbl.push("<tbody><tr>");

    for(var i=0; i<aryBinNames[id_axis].length; i++){
	var n_ok=0;
	var n_expected=0;
	var n_excluded = 0;
	var n_named = 0;

	var scanner = new binScanner(aryCondition);
	scanner.resetCondition(id_axis, i);
	var bContinue = true;
	while(bContinue){
	    var dat = ccdat[coordToIndex(scanner.coord)];
	    if(dat>=at_least){ n_expected++; n_ok++;}
	    else if(dat>=0){ n_expected++; }
	    else if(dat==-1){ n_named++; }
	    else if(dat==-2 || dat==-3){ n_excluded++; }
	    bContinue = scanner.inc();
	}

	strTbl.push("<td ");
	if(pos!=null) strTbl.push("onclick='listExpand(this," + id_axis + "," + i + ")' ");
	if(n_expected>0){
	    var score = (100.0*n_ok/n_expected).toFixed(2);
	    if(score==100) strTbl.push("class='Lv5' ");
	    else if(score>= 80) strTbl.push("class='Lv4' ");
	    else if(score>= 60) strTbl.push("class='Lv3' ");
	    else if(score>= 30) strTbl.push("class='Lv2' ");
	    else if(score>   0) strTbl.push("class='Lv1' ");
	    else if(score==  0) strTbl.push("class='Lv0' ");
	    strTbl.push(">"+score+" ("+ n_ok + "/" + n_expected+")</td>");
	} else strTbl.push(">n/c</td>");
    }    
    strTbl.push("</tr></tbody></table>");


    return strTbl.join('');
}

StatisticView.prototype.draw2dBinChart=function(coord, axHor, axVer, bDynamic)
{
    assert(coord[axHor]==null);
    assert(coord[axVer]==null);
    var strTbl = new Array;

    if(aryDimension[axHor]>aryDimension[axVer]){
	var a = axVer; axVer = axHor; axHor = a;
    }
	  
    
    strTbl.push("<table style='width:40%'>");
    if(bDynamic){
	strTbl.push("<caption>AXIS: ");
	strTbl.push(aryAxisNames[axHor] + "  vs  " + aryAxisNames[axVer]);
	strTbl.push("</caption>");
    }
    strTbl.push("<thead>");
    strTbl.push("<tr><th></th><th colspan='" + aryDimension[axHor] + "'>" + aryAxisNames[axHor] + "</th></tr>");
    strTbl.push("<tr><th style='background-color:white; color:#000;'>"+ aryAxisNames[axVer] + "</th>");
    for(var i=0; i<aryBinNames[axHor].length; i++){
        strTbl.push("<th scope='col'>");
        strTbl.push(aryBinNames[axHor][i]);
        strTbl.push("</th>");
    }
    strTbl.push("</tr></thead>");
    strTbl.push("<tbody>");

    for(var r=0; r<aryBinNames[axVer].length; r++){
        coord[axVer]=r;
        strTbl.push("<tr><th scope='row'>"+aryBinNames[axVer][r]+"</th>");
        for(var c=0; c<aryBinNames[axHor].length; c++) {
            coord[axHor]=c;
            var dat=ccdat[coordToIndex(coord)];
            strTbl.push("<td");
            if(dat>=at_least)strTbl.push(" class='ok'>" + dat);
            else if(dat>=0)  strTbl.push(" class='ng'>" + dat);
            else if(dat==-1) strTbl.push(">named");
            else if(dat==-2) strTbl.push(">excl");
	    else strTbl.push(">illegal");
            strTbl.push("</td>");
        }
        strTbl.push("</tr>");
    }
    strTbl.push("</tbody></table>");

    return strTbl.join('');
}

StatisticView.prototype.draw2dChart = function(cond, axHor, axVer, bDynamic)
{
    assert(cond[axHor]==null);
    assert(cond[axVer]==null);
    var strTbl = new Array;
    this.HorizontalAxis = axHor;
    this.VerticalAxis = axVer;

    strTbl.push("<table class=statTable>");
    if(bDynamic){
	strTbl.push("<caption>AXIS: ");
	for(var i=0; i<cond.length; i++){
	    if(cond[i]==null){
		if(i!=axHor){
		    strTbl.push("<a onclick='chartExpand("+ i + ", null, null)' style='margin-right:20pt;'>");
		    strTbl.push(aryAxisNames[i]);
		    strTbl.push("</a>");
		} else {
		    strTbl.push("<span style='margin-right:20pt;'>");
		    strTbl.push(aryAxisNames[i]);
		    strTbl.push("</span>");
		}
	    }
	}
	strTbl.push("<a onclick='close2DChart(" + axHor + ")'>  [&lt;&lt;close]</a>");
	strTbl.push("</caption>");
    }    
    strTbl.push("<thead>");
    strTbl.push("<tr><th></th><th colspan='" + aryDimension[axHor] + "'>" + aryAxisNames[axHor] + "</th></tr>");
    strTbl.push("<tr>");
    
    strTbl.push("<th style='background-color:white; color:#000;'>");
    if(bDynamic){
	strTbl.push("<select onchange='chartExpand("+ axHor  + ",this.value, null)'>");
	strTbl.push("<option value='"+axVer+"'>" + aryAxisNames[axVer] + "</option>");

	cond[axHor]=0;
	cond[axVer]=0;
	for(var i=0; i<cond.length; i++){
	    if(cond[i]==null){
		strTbl.push("<option value='" + i + "'>" + aryAxisNames[i] + "</option>");
	    }
	}
	strTbl.push("</select>");
    } else {
	strTbl.push(aryAxisNames[axVer]);
    }
    strTbl.push("</th>");
    for(var i=0; i<aryBinNames[axHor].length; i++){
        strTbl.push("<th scope='col'>");
        strTbl.push(aryBinNames[axHor][i]);
        strTbl.push("</th>");
    }
    strTbl.push("</tr></thead>");
    strTbl.push("<tbody>");

    for(var r=0; r<aryBinNames[axVer].length; r++){
        cond[axVer]=r;
        strTbl.push("<tr><th scope='row'>"+aryBinNames[axVer][r]+"</th>");
        for(var c=0; c<aryBinNames[axHor].length; c++) {
            cond[axHor]=c;

            var n_ok=0;
            var n_expected=0;
            var n_excluded = 0;
            var n_named = 0;

            var scanner = new binScanner(cond);
            var bContinue = true;
            while(bContinue){
                var dat = ccdat[coordToIndex(scanner.coord)];
                if(dat>=at_least){ n_expected++; n_ok++;}
                else if(dat>=0){ n_expected++; }
                else if(dat==-1){ n_named++; }
                else if(dat==-2 || dat==-3){ n_excluded++; }
                bContinue = scanner.inc();
            }

            strTbl.push("<td");
            if(n_expected>0){
		if(bDynamic)strTbl.push(" onclick='closeAndAppendChart(" + r + "," + c + ")'");
                var score = (100.0*n_ok/n_expected).toFixed(2);
                if(score==100) strTbl.push(" class='Lv5' ");
                else if(score>= 80) strTbl.push(" class='Lv4'");
                else if(score>= 60) strTbl.push(" class='Lv3'");
                else if(score>= 30) strTbl.push(" class='Lv2'");
                else if(score>   0) strTbl.push(" class='Lv1'");
                else if(score==  0) strTbl.push(" class='Lv0'");
                strTbl.push(">"+score+" ("+ n_ok + "/" + n_expected+")</td>");
            } else strTbl.push(">n/c</td>");
        }
        strTbl.push("</tr>");
    }
    strTbl.push("</tbody></table>");

    return strTbl.join('');
    
}

function switchmode(instname)
{
    var strwriter = new Array;
    strwriter.push('?');
    strwriter.push("cg="+aryQuery['cg']);
    strwriter.push("&cp="+aryQuery['cp']);
    strwriter.push("&target="+aryQuery['target']);
    strwriter.push("&instance="+instname);
    
    location.href = location.protocol + location.pathname + strwriter.join('');
}

