/*
* Copyright (C) 2007-2012 Verifore, Inc.
* All rights reserved. Property of Verifore, Inc.
* Restricted rights to use, duplicate or disclose
* this code are granted through contract.
*/

var cg_name, cp_name, inst_name;
var xml, xslts;
var current_menu_cg;
var filename;
var menuMode;
// 0: CG mode
// 1: CP mode
var menuSortMode;
var total_cumulative_score, total_inst_score;
var menuItems = {};
function initialize()
{
    var aryQuery = new Object;
    aryQuery['target']="";
    if(location.search.length > 1){
	var ary = location.search.substr(1).split("&");
	ary.each(
	    function(str){
		var key_val = str.split("=");
		aryQuery[key_val[0]] = key_val[1];
	    });
    }    
    filename = aryQuery['target'];

    if(filename=="") filename='result.xml';
    
    xslts = new Array(7);
    if(!document.all) { //Mozilla
	xml = document.implementation.createDocument("", "", null);

	for(var i=0; i<xslts.length; i++){
	    xslts[i] = document.implementation.createDocument("", "", null);
	    xslts[i].async = false;
	};
    }
    else {
	xml = new ActiveXObject("Msxml2.DOMDocument");
	for(var i=0; i<xslts.length; i++){
	    xslts[i] = new ActiveXObject("Msxml2.FreeThreadedDOMDocument");
	    xslts[i].async = false;
	}
    }
    xml.async = false;

    xml.load(filename);
    //xslts[0].load('toolbox/Menu.xsl');
    xslts[1].load('toolbox/ViewCCBinGroup.xsl');
    xslts[2].load('toolbox/InfoHeader.xsl');
    xslts[3].load('toolbox/ViewCG.xsl');
    xslts[4].load('toolbox/ViewCP.xsl');
    xslts[5].load('toolbox/ViewBins.xsl');
    xslts[6].load('toolbox/InstanceSelector.xsl');

    // Initial presentation
    cg_name = "";
    cp_name = "";
    inst_name = "";
    current_menu_cg = "";
    menuSortMode = "";
    createMenuItems();
    showRoot();
    currentMode = 0;
	startLogoAnimation();
}

function createMenuItems()
{
    menuItems = [];
    var cgs = selectNodes(xml, "//cg");
    var i=0;
    total_inst_score = parseFloat(xml.documentElement.getAttribute("score_inst"));
    total_cumulative_score = parseFloat(xml.documentElement.getAttribute("score_cumulative"));
    cgs.each(function(cg){
	var cumulativeElem = cg.getElementsByTagName("cumulative")[0];
	var name = cg.getAttribute("name");
	var instScore = parseFloat(cg.getAttribute("inst_score"));
	var cumulativeScore = parseFloat(cumulativeElem.getAttribute("score"));
	var zeroweight = (parseFloat(cg.getAttribute("weight"))==0.0);
	var instUncovered = parseFloat(cg.getAttribute("inst_uncovered"));
	var cumulativeUncovered = parseFloat(cumulativeElem.getAttribute("uncovered"));
	menuItems.push([i++, name, cumulativeScore, instScore, instUncovered, cumulativeUncovered, zeroweight]);
    });

}

function createXSLTProc(idXslt)
{
    createXsltProc(xslts[idXslt]);
}

function transformAndSet(idDiv)
{
    transformXmlAndWriteToDiv(xml,idDiv);
}

function showRoot()
{
    cg_name = "";
    cp_name = "";
    current_menu_cg = "";
    $('instselector').innerHTML = "";
    $('infoHeader').innerHTML = '';
    $('main').innerHTML = '';
    $('infobody').style.visibility='hidden';
    changeMenuToRoot();
    createXSLTProc(3);
    if($('show_weight0').checked){
	setXsltProcParameter('show_weight_zero', 'yes');
    }
    transformAndSet('cglist');
}

function updateInfoHeader()
{
    $('infobody').style.visibility='inherit';
    $('instselector').innerHTML = "";
    $('cglist').innerHTML = "";
    createXSLTProc(6); //ViewCCBinGroup.xsl
    setXsltProcParameter('cg_name', cg_name);
    setXsltProcParameter('instance_name', inst_name);
    if($('show_weight0').checked){
	setXsltProcParameter('show_weight_zero', 'yes');
    }
    transformAndSet('instselector');

    $('infoHeader').innerHTML = "";
    createXSLTProc(2); //InstanceSelector.xsl
    setXsltProcParameter('cg_name', cg_name);
    setXsltProcParameter('cp_name', cp_name);
    setXsltProcParameter('instance_name', inst_name);
    setXsltProcParameter('target_name', filename);
    transformAndSet('infoHeader');
    
}

function updateBody()
{
    $('infobody').style.visibility='inherit';
    $('additional').innerHTML = "";
    $('cglist').innerHTML = "";
    if(cp_name==""){
	if(cg_name==""){ showRoot(); }
	else {
	    $('main').innerHTML = "loading";
	    createXSLTProc(4); //ViewCP.xsl
	    setXsltProcParameter('cg_name', cg_name);
	    setXsltProcParameter('instance_name', inst_name);
	    if($('show_weight0').checked){
		setXsltProcParameter('show_weight_zero', 'yes');
	    }
	    transformAndSet('main');
	}
    }
    else {
	createXSLTProc(5); //ViewBins.xsl
	setXsltProcParameter('cg_name', cg_name);
	setXsltProcParameter('cp_name', cp_name);
	setXsltProcParameter('instance_name', inst_name);
	if($('show_weight0').checked){
	    setXsltProcParameter('show_weight_zero', 'yes');
	}
	transformAndSet('main');
    }
}

var lastSortMode="unsort";
function updateMenu(sortmode)
{
    //check conditions
    // show weight=0
    var bShowWeight0 = $('show_weight0').checked;

    // show inst/cumulative
    var bCumulativeMode = ($('menuMode').value=="cumulative");

    // show score/uncovered
    var bShowScore = ($('scoreMode').value=="score");
    //-----------------------
    var score = (bCumulativeMode)?total_cumulative_score:total_inst_score;
    $('total_score').innerHTML = score;
    $('total_score').className = "Lv" + getScoreColorLevel(score);
    var sortby;
    var compfunc = function(a,b){return a[sortby]-b[sortby];}
    if(sortmode!=undefined){
	lastSortMode = sortmode;
	if(sortmode == "unsort"){ sortby = 0; }
	else{
	    if(sortmode=="byname"){ 
		compfunc = function(a,b){ return a[1].localeCompare(b[1]); }
	    } else {
		if(bCumulativeMode) sortby = (bShowScore)?2:5;
		else sortby = (bShowScore)?3:4;
	    }
	}
	menuItems.sort(compfunc);
	if(sortmode=="byscore" && !bShowScore) menuItems.reverse();
    }
    $('menu_body').innerHTML = "";
    
    menuItems.each(function(item){
	if(!item[6] || bShowWeight0){
	    var tr = document.createElement('tr');
	    $('menu_body').appendChild(tr);
	    var th = document.createElement('th');
	    th.appendChild(document.createTextNode(item[1]));
	    th.className = "menuItem";
	    tr.appendChild(th);
	    var id;
	    var td = document.createElement('td');
	    if(bCumulativeMode) id=(bShowScore)?2:5;
	    else                id=(bShowScore)?3:4;
	    td.appendChild(document.createTextNode(item[id]));
	    var rank =  (bShowScore)?getScoreColorLevel(item[id]):getUncoveredColorLevel(item[id]);
	    td.className = "Lv" + rank;
	    tr.appendChild(td);
	    tr.onclick=function(){showCoverageGroup(item[1]);}

	    if(current_menu_cg==item[1]){
		var input = document.createElement('input');
		input.type = "image";
		input.src = "toolbox/cancel.png";
		input.onclick = changeMenuToRoot;
		th.appendChild(input);
		sortmode = lastSortMode;
		if(bCumulativeMode){
		    var cps = selectNodes(xml, "//cg[@name='" + current_menu_cg +"']/cumulative/*");
		    var menuSubItems = [];
		    cps.each(function(cp){
			var name = cp.getAttribute("name");
			var score = (bShowScore)?parseFloat(cp.getAttribute("score")):parseFloat(cp.getAttribute("uncovered"));
			var zeroweight = parseInt(cp.getAttribute("weight"))==0;
			menuSubItems.push([name, score, zeroweight]);
		    });
		} else {
		    var insts = selectNodes(xml, "//cg[@name='" + current_menu_cg + "']/inst");
		    var menuSubItems = [];
		    insts.each(function(inst){
			var name = inst.getAttribute("instname");
			var score = (bShowScore)?parseFloat(inst.getAttribute("score")):parseFloat(inst.getAttribute("uncovered"));
			var zeroweight =  parseInt(inst.getAttribute("weight"))==0;
			menuSubItems.push([name, score, zeroweight]);
		    });
		}
	    	if(sortmode=="byname"){ menuSubItems.sort(function(a,b){return a[0].localeCompare(b[0]);}); }
    		else if(sortmode=="byscore"){ menuSubItems.sort(function(a,b){return a[1] - b[1];});}

		menuSubItems.each(function(item){
		    if(bShowWeight0 || !item[2]){
			var rank = (bShowScore)?getScoreColorLevel(item[1]):getUncoveredColorLevel(item[1]);
			var tr = document.createElement('tr');
			$('menu_body').appendChild(tr);
			var th=document.createElement('th');
			th.appendChild(document.createTextNode(item[0]));
			th.className="submenu";
			tr.appendChild(th);
			var td = document.createElement('td');
			td.appendChild(document.createTextNode(item[1]));
			td.className = "Lv" + rank;
			tr.appendChild(td);
			if(bCumulativeMode) tr.onclick=function(){showCoveragePoint(current_menu_cg, item[0]);}
			else                tr.onclick=function(){showInstance(current_menu_cg, item[0]);}
		    }
		});
	    }
	}
    });

}
function getScoreColorLevel(score){
    if(score==0.0)       return 0;
    else if(score<=30.0) return 1;
    else if(score<=60.0) return 2;
    else if(score<=80.0) return 3;
    else if(score<100)   return 4;
    else return 5;
}
function getUncoveredColorLevel(score){
    if(score>=4.0)      return 0;
    else if(score>=3.0) return 1;
    else if(score>=2.0) return 2;
    else if(score>=1.0) return 3;
    else if(score>0.0)  return 4;
    else return 5;
}
function updateAll()
{
    updateMenu();
    updateInfoHeader();
    updateBody();
}

function showCoverageGroup(inCgName)
{
    cg_name = inCgName;
    cp_name = "";
    inst_name = "";
    changeMenuToCps(inCgName);
    updateInfoHeader();
    updateBody();
}

function showCoveragePoint(inCgName, inCpName)
{
    cg_name = inCgName;
    cp_name = inCpName;
    inst_name = "";

    changeMenuToCps(inCgName);
    updateInfoHeader();
    updateBody();
}

function changeMenuToCps(inCgName)
{
    current_menu_cg = inCgName;
    updateMenu();
}

function changeMenuToRoot()
{
    current_menu_cg = "";
    updateMenu();
}

function showBinGroup(bin_name)
{
    createXSLTProc(1);
    setXsltProcParameter('cg_name', cg_name);
    setXsltProcParameter('cp_name', cp_name);
    setXsltProcParameter('bn_name', bin_name);
    setXsltProcParameter('instance_name', inst_name);
    transformAndSet('additional');
}

function switchmode(instname)
{
    inst_name=instname;
    updateInfoHeader();
    updateBody();
}
function showInstance(inCgName, instname)
{
    cg_name = inCgName;
    inst_name = instname;
    updateInfoHeader();
    updateBody();
}
