<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
  <xsl:output method="html" media-type="text/html" omit-xml-declaration="yes" />
  <xsl:param name="cg_name" select="'busy_range_cg'" />
  <xsl:param name="cp_name" select="'w_busy_range_xc'" />
  <xsl:param name="bn_name" select="'BUSY_8_15'" />
  <xsl:param name="mode" select="'cumulative'" />

  <xsl:template match="/">
    <xsl:apply-templates selct="testbench" />
  </xsl:template>
  
  <xsl:template match="testbench">
    <xsl:choose>
      <xsl:when test="$mode='inst'"><xsl:apply-templates select="cg[@name=$cg_name]/inst/cc[@name=$cp_name]/bn[@name=$bn_name]" /></xsl:when>
      <xsl:otherwise><xsl:apply-templates select="cg[@name=$cg_name]/cumulative/cc[@name=$cp_name]/bn[@name=$bn_name]" /></xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  
  <xsl:template match="bn">
    <table summary="axis_table" class="maintable">
      <caption>
	named bin [<xsl:value-of select="$bn_name" />]
      </caption>
      <thead>
	<xsl:for-each select="crosspoints/axis">
	  <th scope="col"><xsl:value-of select="@name" /></th>
	</xsl:for-each>
      </thead>
      <tbody>
	<xsl:apply-templates />
      </tbody>
    </table>
  </xsl:template>

  <xsl:template match="domain">
    <tr>
      <xsl:for-each select="axis">
	<td><xsl:value-of select="@description" /></td>
      </xsl:for-each>
    </tr>
  </xsl:template>
  
</xsl:stylesheet>