<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
  <xsl:output method="html" media-type="text/html" omit-xml-declaration="yes" />
  <xsl:param name="cg_name" select="'incr_range_cg'" />
  <xsl:param name="cp_name" select="'xact_type_cp'" />
  <xsl:param name="instance_name" select="''" />
  
  <xsl:template match="/">
    <xsl:apply-templates select="testbench"/>
  </xsl:template>
  
  <xsl:template match="testbench">
     <table summary="bin_table" class="maintable">
      <caption>
	bin list [<xsl:value-of select="$cg_name" />/<xsl:value-of select="$cp_name" />]
      </caption>
      <thead>
	<tr>
	  <th scope="col" class="namecol">name</th>
	  <th scope="col">count</th>
	  <th scope="col" class="scorecol">state</th>
	</tr>
      </thead>
      <tbody>
	<xsl:choose>
	  <xsl:when test="$instance_name!=''"><xsl:apply-templates select="cg[@name=$cg_name]/inst[@instname=$instance_name]/*[@name=$cp_name]/bn" /></xsl:when>
	  <xsl:otherwise><xsl:apply-templates select="cg[@name=$cg_name]/cumulative/*[@name=$cp_name]/bn" /></xsl:otherwise>
	</xsl:choose>
      </tbody>
    </table>
   </xsl:template>
  
  <xsl:template name="table_data">
    <tr>
      <th scope="row">
	<xsl:choose>
	  <xsl:when test="domain">
	    <a>
	      <xsl:attribute name="onclick">showBinGroup('<xsl:value-of select="@name" />')</xsl:attribute>
	      <xsl:value-of select="@name" />
	    </a>
	  </xsl:when>
	  <xsl:otherwise>
	    <xsl:value-of select="@name" />
	  </xsl:otherwise>
	</xsl:choose>
      </th>
      <td><xsl:value-of select="@count" /></td>
      <td>
	<xsl:call-template name="state" />
	<xsl:choose>
	  <xsl:when test="@excl='true'">excluded</xsl:when>
	  <xsl:when test="@ignored='true'">ignored</xsl:when>
	  <xsl:when test="@illegal='true'">illegal</xsl:when>
	  <xsl:when test="@count&gt;=../@at_least">
	    ok
	  </xsl:when>
	  <xsl:otherwise>
	    ng
	  </xsl:otherwise>
	</xsl:choose>
      </td>
    </tr>
  </xsl:template>
  
  <xsl:template name="state">
    <xsl:choose>
      <xsl:when test="@excl='true'"><xsl:attribute name="class">invalid</xsl:attribute></xsl:when>
      <xsl:when test="@ignored='true'"><xsl:attribute name="class">invalid</xsl:attribute></xsl:when>
      <xsl:when test="@illegal='true'"><xsl:attribute name="class">invalid</xsl:attribute></xsl:when>
      <xsl:when test="@count&gt;=../@at_least"><xsl:attribute name="class">ok</xsl:attribute></xsl:when>
      <xsl:otherwise><xsl:attribute name="class">ng</xsl:attribute></xsl:otherwise>
    </xsl:choose>    
  </xsl:template>

  <xsl:template match="bn">
    <xsl:call-template name="table_data" />
  </xsl:template>
</xsl:stylesheet>
