<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
  <xsl:output method="html" media-type="text/html" omit-xml-declaration="yes" />

  <xsl:param name="cg_name" select="'busy_range_cg'" />
  <xsl:param name="cp_name" select="'wr_busy_range_xc'" />
  <xsl:param name="bn_name" select="'BUSY_8_15'" />
  <xsl:param name="instance_name" select="''" />
  
  <xsl:template match="/">
    <xsl:apply-templates select="testbench" />
  </xsl:template>

  <xsl:template match="testbench">
    <table summary="axis_table" class="maintable">
      <caption>
	named bin [<xsl:value-of select="$bn_name" />]
      </caption>
      <xsl:choose>
	<xsl:when test="$instance_name!=''"><xsl:apply-templates select="cg[@name=$cg_name]/inst[@instname=$instance_name]/cc[@name=$cp_name]/bn[@name=$bn_name]" /></xsl:when>
	<xsl:otherwise><xsl:apply-templates select="cg[@name=$cg_name]/cumulative/cc[@name=$cp_name]/bn[@name=$bn_name]" /></xsl:otherwise>
      </xsl:choose>
    </table>
  </xsl:template>

  <xsl:template match="bn">
    <thead>
      <tr>
	<xsl:for-each select="../crosspoints/axis">
	  <th scope="col"><xsl:value-of select="@name" /></th>
	</xsl:for-each>
      </tr>
    </thead>
    <tbody>
      <xsl:for-each select="domain">
	<tr>
	  <xsl:for-each select="axis">
	    <td><xsl:value-of select="@description" /></td>
	  </xsl:for-each>
	</tr>
      </xsl:for-each>
    </tbody>
  </xsl:template>
</xsl:stylesheet>