<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:param name="cg_name" select="'first_dly_cg'" />
	<xsl:param name="cc_name" select="'first_dly_xc'" />
	<xsl:param name="instance_name" select="''" />
  
	<xsl:template match="/">
		<xsl:choose>
			<xsl:when test="$instance_name!=''">
				<xsl:apply-templates select="testbench/cg[@name=$cg_name]/inst[@instname=$instance_name]/cc[@name=$cc_name]" />
			</xsl:when>
			<xsl:otherwise>
				<xsl:apply-templates select="testbench/cg[@name=$cg_name]/cumulative/cc[@name=$cc_name]" />
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

  <xsl:template match="cc">
    <xsl:param name="ccname" select="@name" />
    <xsl:copy>
      <xsl:apply-templates select="@*" />
      <xsl:attribute name="classname"><xsl:value-of select="../../cumulative/@class"/></xsl:attribute>
      <xsl:apply-templates select="../../cumulative/cc[@name=$ccname]/crosspoints" />
      <xsl:apply-templates select="../../cumulative/cc[@name=$ccname]/excluded_crosses" />
      <xsl:apply-templates select="../../cumulative/cc[@name=$ccname]/illegal_auto_crosses" />
      <xsl:apply-templates select="namedbins|data" />
    </xsl:copy>
  </xsl:template>
  
	<xsl:template match="crosspoints">
		<xsl:copy>
			<xsl:apply-templates select="@*" />
			<xsl:apply-templates select="axis" />
		</xsl:copy>
	</xsl:template>

	<xsl:template match="axis">
		<xsl:param name="cpname" select="@name" />
		<xsl:copy>
			<xsl:apply-templates select="@*" />
			<xsl:apply-templates select="../../../cp[@name=$cpname]/bn" />
		</xsl:copy>
	</xsl:template>

	<xsl:template match="bn">
		<xsl:copy>
			<xsl:apply-templates select="@name" />
		</xsl:copy>
	</xsl:template>

  <xsl:template match="@*|excluded_crosses|illegal_auto_crosses|namedbins|data">
    <xsl:copy-of select="." />
  </xsl:template>
</xsl:stylesheet>
