<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
  <xsl:output method="html" media-type="text/html" omit-xml-declaration="yes" />
  
  <xsl:template match="/">
    <xsl:apply-templates select="cc" />
  </xsl:template>

  <xsl:template name="ranking">
    <xsl:param name="score" />
    <xsl:choose>
      <xsl:when test="$score=100"><xsl:attribute name="class">Lv5</xsl:attribute></xsl:when>
      <xsl:when test="$score&gt;=80"><xsl:attribute name="class">Lv4</xsl:attribute></xsl:when>
      <xsl:when test="$score&gt;=60"><xsl:attribute name="class">Lv3</xsl:attribute></xsl:when>
      <xsl:when test="$score&gt;=30"><xsl:attribute name="class">Lv2</xsl:attribute></xsl:when>
      <xsl:when test="$score&gt; 0"><xsl:attribute name="class">Lv1</xsl:attribute></xsl:when>
      <xsl:when test="$score=0"><xsl:attribute name="class">Lv0</xsl:attribute></xsl:when>
      <xsl:otherwise></xsl:otherwise>
    </xsl:choose>    
  </xsl:template>

  <xsl:template match="cc">
    <table summary="cc_view_table" id="statHeader">
      <caption>Cross Coverage Point</caption>
      <thead>
	<tr>
	  <th scope="col" class="namecol">name</th>
	  <th scope="col">class</th>
	  <th scope="col" class="countcol">combination</th>
	  <th scope="col" class="countcol">excluded</th>
	  <th scope="col" class="countcol">illegal</th>
	  <th scope="col" class="countcol">named</th>
	  <th scope="col" class="countcol">expected</th>
	  <th scope="col" class="countcol">ok</th>
	  <th scope="col" class="scorecol">score</th>
	</tr>
      </thead>
      <tbody>
	<tr>
	  <td><xsl:value-of select="@name" /></td>
	  <td><xsl:value-of select="@classname" /></td>
	  <xsl:apply-templates select="data" />
	</tr>
      </tbody>
    </table>
  </xsl:template>

  <xsl:template match="data">
    <td><xsl:value-of select="@named+@excluded+@expected+@illegal" /></td>
    <td><xsl:value-of select="@excluded" /></td>
    <td><xsl:value-of select="@illegal" /></td>
    <td><xsl:value-of select="@named" /></td>
    <td><xsl:value-of select="@expected" /></td>
    <td><xsl:value-of select="@ok" /></td>
    <td>
      <xsl:call-template name="ranking"><xsl:with-param name="score" select="@score"/></xsl:call-template>
      <xsl:value-of select="@score" />
    </td>
  </xsl:template>
</xsl:stylesheet>
