<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
  <xsl:param name="show_weight_zero" select="'no'" />
  <xsl:template match="/">
    <xsl:apply-templates select="testbench"/>
  </xsl:template>
  
  <xsl:template match="testbench">
    <table summary="cg_table" class="maintable">
      <caption>group list</caption>
      <thead>
	<tr>
	  <th scope="col" class="namecol">name</th>
	  <th scope="col">class</th>
	  <th scope="col">description</th>
	  <th scope="col" class="countcol">weight</th>
	  <th scope="col" class="scorecol">score</th>
	  <th scope="col" class="scorecol">inst score</th>
	</tr>
      </thead>
      <tbody>
	  <xsl:apply-templates select="cg/cumulative" />
      </tbody>
    </table>
  </xsl:template>
  
  <xsl:template name="ranking">
    <xsl:param name="score" />
    <xsl:choose>
      <xsl:when test="$score=100"><xsl:attribute name="class">Lv5</xsl:attribute></xsl:when>
      <xsl:when test="$score&gt;=80"><xsl:attribute name="class">Lv4</xsl:attribute></xsl:when>
      <xsl:when test="$score&gt;=60"><xsl:attribute name="class">Lv3</xsl:attribute></xsl:when>
      <xsl:when test="$score&gt;=30"><xsl:attribute name="class">Lv2</xsl:attribute></xsl:when>
      <xsl:when test="$score&gt; 0"><xsl:attribute name="class">Lv1</xsl:attribute></xsl:when>
      <xsl:when test="$score=0"><xsl:attribute name="class">Lv0</xsl:attribute></xsl:when>
      <xsl:otherwise></xsl:otherwise>
    </xsl:choose>    
  </xsl:template>
    
  <xsl:template match="cumulative">
    <xsl:if test="@weight&gt;0 or $show_weight_zero='yes'">
      <tr>
	<th scope="row">
	  <a>
	    <xsl:attribute name="onclick">showCoverageGroup('<xsl:value-of select="@name"/>')</xsl:attribute>
	    <xsl:value-of select="@name" />
	  </a>
	</th>
	<td><xsl:value-of select="@class" /></td>
	<td><xsl:value-of select="@description" /></td>
	<td><xsl:value-of select="@weight" /></td>
	<td>
	  <xsl:call-template name="ranking"><xsl:with-param name="score" select="@score"/></xsl:call-template>
	  <xsl:value-of select="@score" />
	</td>
	<td>
	  <xsl:call-template name="ranking"><xsl:with-param name="score" select="../@inst_score"/></xsl:call-template>
	  <xsl:value-of select="../@inst_score" />
	</td>
      </tr>
    </xsl:if>
  </xsl:template>
</xsl:stylesheet>
