<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
  <xsl:output method="html" media-type="text/html" omit-xml-declaration="yes" />
  <xsl:param name="cg_name" select="'busy_range_cg'" />
  <xsl:param name="show_weight_zero" select="'no'" />
  <xsl:param name="instance_name" select="''" />
  
  <xsl:template match="/">
    <xsl:apply-templates select="testbench"/>
  </xsl:template>
  
  <xsl:template match="testbench">
    <table summary="cp_table" class="maintable">
      <caption>coverage-points list [<xsl:value-of select="$cg_name" />]</caption>
      <thead>
	<tr>
	  <th scope="col" class="namecol">name</th>
	  <th scope="col">description</th>
	  <th scope="col" class="countcol">#expected</th>
	  <th scope="col" class="countcol">#OKs</th>
	  <th scope="col" class="countcol">weight</th>
	  <th scope="col" class="scorecol">score</th>
	</tr>
      </thead>
      <tbody>
	<xsl:choose>
	  <xsl:when test="$instance_name!=''"><xsl:apply-templates select="cg[@name=$cg_name]/inst[@instname=$instance_name]" /></xsl:when>
	  <xsl:otherwise><xsl:apply-templates select="cg[@name=$cg_name]/cumulative" /></xsl:otherwise>
	</xsl:choose>
      </tbody>
    </table>
  </xsl:template>
  
  
  <xsl:template name="ranking">
    <xsl:param name="score" />
    <xsl:choose>
      <xsl:when test="$score=100"><xsl:attribute name="class">Lv5</xsl:attribute></xsl:when>
      <xsl:when test="$score&gt;=80"><xsl:attribute name="class">Lv4</xsl:attribute></xsl:when>
      <xsl:when test="$score&gt;=60"><xsl:attribute name="class">Lv3</xsl:attribute></xsl:when>
      <xsl:when test="$score&gt;=30"><xsl:attribute name="class">Lv2</xsl:attribute></xsl:when>
      <xsl:when test="$score&gt; 0"><xsl:attribute name="class">Lv1</xsl:attribute></xsl:when>
      <xsl:when test="$score=0"><xsl:attribute name="class">Lv0</xsl:attribute></xsl:when>
      <xsl:otherwise></xsl:otherwise>
    </xsl:choose>    
  </xsl:template>

  <xsl:template match="cp | cc">
    <xsl:if test="@weight&gt;0 or $show_weight_zero='yes'">
      <tr>
	<th scope="row">
	  <a>
	    <xsl:attribute name="onclick">showCoveragePoint('<xsl:value-of select="$cg_name" />','<xsl:value-of select="@name"/>')</xsl:attribute>
	    <xsl:value-of select="@name" />
	  </a>
	</th>
	<td><xsl:value-of select="@description" /></td>
	<td><xsl:value-of select="@expected" /></td>
	<td><xsl:value-of select="@ok" /></td>
	<td><xsl:value-of select="@weight" /></td>
	<td>
	  <xsl:call-template name="ranking"><xsl:with-param name="score" select="@score"/></xsl:call-template>
	  <xsl:value-of select="@score" />
	</td>
      </tr>
    </xsl:if>
  </xsl:template>
</xsl:stylesheet>