/*
* Copyright (C) 2007-2012 Verifore, Inc.
* All rights reserved. Property of Verifore, Inc.
* Restricted rights to use, duplicate or disclose
* this code are granted through contract.
*/

var Animator = Class.create();
Animator.prototype ={
  interval:100,
  steps:[],
  proc:{},
  fin:{},
  id:null,
    
  initialize:function(interval, steps, proc, fin){
      this.interval = interval;
      this.steps = steps;
      this.proc = proc;
      this.fin = fin;
  },
  doAnimation:function(){
      var _this = this;
      var next;
      (next = function() {
          _this.proc(_this.steps.shift());
          if(_this.steps.length>0)
            _this.id = window.setTimeout(next, _this.interval);
          else
            _this.fin();
      })();
  },
  stop:function(){
      if(this.id!=null){
        clearTimeout(this.id);
	this.id = null;
      }
  }
};


function createFrictionStopSteps(x,y,vx,vy)
{
    if(vx*vx+vy*vy<256) return [[x,y]];
    // 10 steps to stop by friction
    var ds = Math.pow(0.05, 0.1 /*=1.0/10*/);
    var ret = new Array(5);

    for(var i=0; i<10; i++){
        vx *= ds; vy*=ds;
        x=x+Math.round(vx);
        y=y+Math.round(vy);
        ret[i] = [x, y];
    }
    return ret;
}
function createLinearMotionSteps(dx,dy)
{
  var steps = [0.0, 0.05, 0.1, 0.2, 0.5, 0.7, 0.9, 0.95, 1.0];
  var ret = new Array(steps.length);
  for(var i=0; i<steps.length; i++){
    ret[i] = [Math.round(steps[i]*dx), Math.round(steps[i]*dy)]
  }
  return ret;
}
